<?php
/*
Plugin Name: Easy Page Link for WPML
Plugin URI: http://forestmist.org/wordpress/easy-page-link-for-wpml/
Description: Enables the TinyMCE link list option with WPML support for multiple languages.
Version: 0.0.8
Author: Daniel Gagan
Author URI: http://forestmist.org/

License

	Copyright 2011 Daniel Gagan (wordpress@forestmist.org)

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

Compatible With
	
	WordPress 2.6+
	WPML 1.6.0+
	
	Chrome 4
	Firefox 3.6
	Internet Explorer 6, 7, 8
	Safari 4
	
Version History

	0.0.8 (2011-05-02)
	WPML has transitioned to a commercial product so this plugin is no longer being developed.
	Please feel free to use the code for anything you wish.
	So long, and thanks for all the fish.
	
	0.0.7 (2010-08-31)
	Fixed issue which would break the TinyMCE editor in custom posts that don't have WPML functionality or if WPML was disabled completely.
	Improved client side JavaScript.
	
	0.0.6 (2010-07-07)
	Improved the filtering logic to work better with custom posts.
	Added new settings menu with helpful information for troubleshooting and an advanced option for Sticky Links.
	
	0.0.5 (2010-06-28)
	Added support for WordPress 3.0
	
	0.0.4 (2010-03-11)
	Added support for editing with SSL.
	Added support for nonstandard wp-config.php locations. 
	Added support for ampersands, backslashes and quotes in titles.
	Added TinyMCE Advanced plugin interoperability.
	Improved reliability.
	
	0.0.3 (2010-01-30)
	Fixed paths to enable WordPress to install the plugin without manual intervention.
	Added support for dashes in titles.
	
	0.0.2 (2010-01-27)
	Fixed imperialistic tendency to have English as the default language. :o
	Improved hierarchy display so it is no longer dependent on there being translations of the default language.
	
	0.0.1 (2010-01-26)
	Initial version based on 'AWS Easy Page Link' by Derek Ashauer of http://ashwebstudio.com/.

*/

$language_code = @$_GET["lc"];

if($language_code == '') {

	function easy_page_link_for_wpml($initArray){
	   global $post;
	   $initArray['external_link_list_url'] = site_url() . '/wp-content/plugins/easy-page-link-for-wpml/easy-page-link-for-wpml.php?lc=__';
	   $initArray['eplfw'] = '", setup: function(ed) { ed.onBeforeExecCommand.add(function(ed, cmd, ui, val) { if(cmd == "mceLink" || cmd == "mceAdvLink") {			if(document.getElementById(\'icl_post_language\') != null) {			tinyMCE.activeEditor.settings.external_link_list_url = tinyMCE.activeEditor.settings.external_link_list_url.substr(0, tinyMCE.activeEditor.settings.external_link_list_url.length-2) + document.getElementById(\'icl_post_language\')[document.getElementById(\'icl_post_language\').selectedIndex].value;			}			} }); }, eplfw2:"';
	   
	   return $initArray;
	}
	
	add_filter('tiny_mce_before_init', 'easy_page_link_for_wpml');
	
} else {
	// language code like "en" was provided so lets build an array for TinyMCE to populate the link list select item

	require_once('../../../wp-load.php');
	
	$hierarchy_spacer = '|--';
	
	$icl_settings = get_option('icl_sitepress_settings');
	$icl_default_language = $icl_settings['default_language'];
	
	class eplfw_class {	
		function eplfw_filter($arr){
			global $wpdb;
			$excl_pages = $wpdb->get_col("SELECT t.element_id FROM {$wpdb->prefix}icl_translations t WHERE t.language_code <> '{$_GET["lc"]}' AND t.language_code <> '' AND (t.element_type = 'page' OR t.element_type = 'post_page')");

			foreach($arr as $page){
				if(!in_array($page->ID,$excl_pages)){
					$filtered_pages[] = $page;
				}
			}        
			return $filtered_pages;
		}
	}
	$eplfw_class = new eplfw_class;
	
	//temporarily stop sitepress from filtering pages
    remove_filter('get_pages', array($sitepress, 'exclude_other_language_pages2'));
	add_filter('get_pages', array($eplfw_class, 'eplfw_filter'));
	
	$pages = get_pages('sort_column=menu_order');
	
	echo 'var tinyMCELinkList = new Array(';

	function get_page_level ($page) {	
		if ($page->post_parent == 0) {
			return 0;
		} else {
			$i = 0;
			$parent = get_post($page->post_parent); // Get initial page's parent
			$loop = 1;
			while ($i < 10) {
				$i++;
				if ($parent->post_parent == 0) // If this post parent is a root, then end the loop
					return $i;
				else // Otherwise, get the parent to the parent and try again
					$parent = get_post($parent->post_parent);
			}
		}
	}
	
	$i = 0;
	$output = '';
	
	if(is_array($pages)) {
		foreach ($pages as $post_item) {
			$i++;
			
			setup_postdata($post_item);

			$select_indent = str_repeat($hierarchy_spacer, get_page_level($post_item));
			
			$title = get_the_title($post_item);
			$title = str_replace('&#038;', '&', $title);
			$title = str_replace('&#8211;', '0', $title);
			$title = str_replace('&#8216;', '\'', $title);
			$title = str_replace('&#8217;', '\'', $title);
			$title = str_replace('&#8221;', '"', $title);
			$title = str_replace('\\', '\\\\', $title);
			$title = str_replace('"', '\"', $title);
			
			if(get_option('eplfw_short_links') == 1) {
				$url = '/?p=' . get_the_ID();
			} else {
				$url = get_permalink($post_item);
			}
					
			$output .= '["' . $select_indent . $title . '", "' . $url . '"], ';
		}
	}	
	
	if($i > 0) {
		//strip uneeded comma from the end
		$output = substr($output, 0, -2);
	}
	
	echo $output . ');';
	
	remove_filter('get_pages', array($eplfw_class, 'eplfw_filter'));
	add_filter('get_pages', array($sitepress, 'exclude_other_language_pages2'));	
}

// create custom plugin settings menu
add_action('admin_menu', 'eplfw_create_menu');

function eplfw_create_menu() {

	//create new top-level menu
	add_menu_page('EPLFW Plugin Settings', 'EPL for WPML', 'administrator', __FILE__, 'eplfw_settings_page',plugins_url('/icon.png', __FILE__));

	//call register settings function
	add_action( 'admin_init', 'register_mysettings' );
}

function register_mysettings() {
	//register our settings
	register_setting( 'eplfw-settings-group', 'eplfw_short_links' );
}

function eplfw_settings_page() {
	global $wpdb;
	?>
	<div class="wrap">
	<h2>Easy Page Link for WPML</h2>

	<h3>Troubleshooting Information</h3>

<textarea style="width: 700px; height: 300px;">
<?php
$db_version = $wpdb->get_var("SELECT option_value from {$wpdb->prefix}options WHERE option_name = 'db_version'");
echo 'Database Version = ' . $db_version . chr(13);

$languages = $wpdb->get_col("SELECT DISTINCT d.language_code FROM {$wpdb->prefix}icl_translations d ORDER by d.language_code");
if ($languages) {	
	echo 'Languages = ' . join(', ', $languages) . chr(13);
	
	foreach ($languages as $lang) {
		$ids = $wpdb->get_col("SELECT d.element_id FROM {$wpdb->prefix}icl_translations d WHERE d.language_code = '{$lang}' AND (d.element_type = 'page' OR d.element_type = 'post_page') ORDER by d.element_id");
		if($ids) {
			$ids = join(', ', $ids);
		} else {
			$ids = 'None';
		}
		echo 'IDs for ' . $lang . ' = ' . $ids . chr(13);
	}
} else {
	$languages = 'No languages found in database table ' . $wpdb->prefix . 'icl_translations.';
	echo 'Languages = ' . $languages . chr(13);
}
?>
</textarea>

	<h3>Settings</h3>
	<form method="post" action="options.php">
		<?php settings_fields( 'eplfw-settings-group' ); ?>
		<table>
		<tr valign="top">
			<td><input type="checkbox" name="eplfw_short_links" value="1" <?php if(get_option('eplfw_short_links') == 1) echo 'checked="checked"'; ?> />&nbsp;</td>
			<td>Enable Short Links<br />
			<em>Returns links formatted as '/?p=123' instead of a full URL to improve tinyMCE editor performance for larger sites. Best used in conjuction with WPML's Sticky Links feature so your visitors can still see pretty URLs.</td>
		</tr>
		</table>
		
		<p class="submit">
		<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
		</p>

	</form>

	</div>
<?php } ?>